/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>
#include <amxmisc>

#define MAX_CLR 7

new ncolors[MAX_CLR][] = {"white","red","green","blue","yellow","magenta","cyan"}
new vcolors[MAX_CLR][3] = {{255,255,255},{255,0,0},{0,255,0},{0,0,255},
													{255,255,0},{255,0,255},{0,255,255}}

new msgchannel = 0

public admin_chat(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32], players[32], inum, authid[16], userid, uaccess
	read_args(message,191)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	get_players(players,inum)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" chat ^"%s^"",name,userid,authid,message)
	format(message,191,"(ADMINS) %s :   %s",name,message)
	console_print(id,message)
	for(new i = 0; i < inum; ++i){
		uaccess = get_user_flags(players[i])
		if ( uaccess && !(uaccess & ADMIN_USER) )
			client_print(players[i],print_chat,message)
	}
	return PLUGIN_HANDLED
}

public admin_say(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32],authid[16], userid
	read_args(message,191)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	client_print(0,print_chat,"(ALL) %s :   %s",name,message)
	console_print(id,"(ALL) %s :   %s",name,message)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" say ^"%s^"",	name,userid,authid,message)
	return PLUGIN_HANDLED
}

public admin_psay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new text[32],name[32]
	read_args(text,31)
	parse(text,name,31)
	new priv = find_player("c",name)
	if (!priv) priv = find_player("bl",name)
	if (!priv){
		console_print(id,"Client with that authid or part of nick not found")
		return PLUGIN_HANDLED
	}
	new length = strlen(name) + 1
	new message[192], name2[32],authid[16],authid2[16], userid
	get_user_authid(id,authid,15)
	get_user_name(id,name2,31)
	userid = get_user_userid(id)	
	read_args(message,191)
	get_user_name(priv,name,31)
	if (id!=priv) client_print(id,print_chat,"(%s) %s :   %s",name,name2,message[length])
	client_print(priv,print_chat,"(%s) %s :   %s",name,name2,message[length])
	console_print(id,"(%s) %s :   %s",name,name2,message[length])
	get_user_authid(priv,authid2,15)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" psay ^"%s<%d><%s><>^" ^"%s^"",
			name2,userid,authid,name,get_user_userid(priv),authid2,message[length])
	return PLUGIN_HANDLED
}

public admin_tsay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new color[12], message[192], name[32], authid[16], userid = 0
	read_args(message,191)
	parse(message,color,11)
	new found = 0,a = 0
	for(new i=0;i<MAX_CLR;++i)
		if (equal(color,ncolors[i])) {
			a = i
			found = 1
			break
		}
	new length = found ? (strlen(color) + 1) : 0
	if (++msgchannel>6||msgchannel<3)
		msgchannel = 3
	new Float:verpos = 0.55 + float(msgchannel) / 35.0
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	set_hudmessage(vcolors[a][0], vcolors[a][1], vcolors[a][2], 0.05, verpos, 0, 6.0, 6.0, 0.5, 0.15, msgchannel)
	show_hudmessage(0,"%s :   %s",name,message[length])
	console_print(id,"%s :   %s",name,message[length])
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" tsay ^"%s^"",name,userid,authid,message[length])
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Admin Chat","0.8","default")
	register_concmd("amx_say","admin_say",ADMIN_CHAT,"<message>")
	register_concmd("amx_chat","admin_chat",ADMIN_CHAT,"<message>")
	register_concmd("amx_psay","admin_psay",ADMIN_CHAT,"<authid or part of nick> <message>")
	register_concmd("amx_tsay","admin_tsay",ADMIN_CHAT,"<color> <message>")
	return PLUGIN_CONTINUE
}
