/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

/* cvars:
*  sets how many slots we want to keep for admins
*  amx_reserved_slots < value >
*
*  sets kicking rules to keep one free place on server
*  unless amx_reserved_slots is reached
*  amx_reservation < value >
*  0 - don't kick anyone (keep slots from amx_reserved_slots
*  only for players with reservation)
*  1 - kick by shortest playing time
*  2 - kick by worst ping
*/

new maxplayers

kick_player(id){
	if (!id) return
	new authid[16],name[32]
	get_user_name(id,name,31)
	get_user_authid(id,authid,15)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" drop due to slot reservation",
		name,get_user_userid(id),authid)
	if (is_user_bot(id))
		server_cmd("kick #%d",get_user_userid(id))
	else
		client_cmd(id,"echo * Dropped due to slot reservation;disconnect")	
}

kick_lag(){
	new players[32], inum
	get_players(players,inum)
	new who=0, ping, loss, worst
	for(new a = 0; a < inum; ++a) {
		if (get_user_flags(players[a])&ADMIN_RESERVATION)
			continue
		get_user_ping(players[a],ping,loss)
		if (!who || (ping>worst)) {
			worst = ping
			who = players[a]
		}
	}
	kick_player(who)
}

kick_fresh(){
	new players[32], inum
	get_players(players,inum)
	new who=0, time, shortest
	for(new a = 0; a < inum; ++a) {
		if (get_user_flags(players[a])&ADMIN_RESERVATION)
			continue
		time = get_user_time(players[a])
		if (!who || (shortest>time)){
			shortest = time 
			who = players[a]
		}
	}
	kick_player(who)
}

get_reserved_usage(){
	new inum = 0, imax = maxplayers + 1
	for(new a = 1; a < imax; ++a)	{
		if (!is_user_connected(a)&&!is_user_connecting(a))
			continue
		if (get_user_flags(a)&ADMIN_RESERVATION)
			++inum
	}
	return inum
}

/* If there is at least one place then allow enter the game anyone.
* If the slots are reserved and not all filled then kick
* with amx_reservation rules.
*/
public client_connect(id){
	new rmax, rnum
	switch(check_slots(id,rnum,rmax)){
		case 1:	client_cmd(id,"echo ^"* You are using reserved slot (%d/%d)^"",rnum,rmax)
		case 2: return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

check_slots(id,&rnum,&rmax){
	new restype = get_cvar_num("amx_reservation")
	rmax = get_cvar_num("amx_reserved_slots")
	new nplayers = get_playersnum()
	if (restype){
		if (nplayers < maxplayers)
			return 0
		rnum = get_reserved_usage()
		new resleft = rmax - rnum
		if (get_user_flags(id)&ADMIN_RESERVATION){
			if (resleft>0){
				switch(restype){
				case 1: kick_fresh()
				case 2: kick_lag()
				}
			}
			return 1
		}
		if (resleft>0) kick_player(id)
		return 2
	}
	else if (nplayers > maxplayers - rmax) {
		rnum = get_reserved_usage()
		if (get_user_flags(id)&ADMIN_RESERVATION)
			return 1
		if (nplayers - rnum > maxplayers - rmax) {
			kick_player(id)
			return 2
		}
	}
	return 0
}

/* Make sure we have one free place if needed. */
public client_putinserver(id){
	new rmax, rnum
	check_slots(id,rnum,rmax)
	return PLUGIN_CONTINUE
}

public plugin_init(){
	register_plugin("Slots Reservation","0.8.2","default")
	register_cvar("amx_reserved_slots","2")
	register_cvar("amx_reservation","1")
	maxplayers = get_maxplayers()
	return PLUGIN_CONTINUE
}
